﻿using MySql.Data.MySqlClient;

namespace Program1;

// Demonstrates a bug that was introduced fixing MySQL bug 107110 (https://bugs.mysql.com/bug.php?id=107110)
// Commit https://github.com/mysql/mysql-connector-net/commit/e72ba5d96bc3da1f04564eb0b7821d2959c560dd
class Program
{
    static void Main(string[] args)
    {
        string connectionString = "server=127.0.0.1;User Id=scott;password=tiger;database=test_db;";
        SetupData(connectionString);

        using (var connection = new MySqlConnection(connectionString))
        {
            connection.Open();
            using (var transaction = connection.BeginTransaction())
            {
                using var command = connection.CreateCommand();
                command.CommandText = "select * from tmp_mysql_connector_testing where id = 1 for update";
                command.ExecuteNonQuery();
                Console.WriteLine("Program1: Transaction in progress: press Enter to rollback");
                Console.ReadLine();
            }
            Console.WriteLine("Program1: Transaction rolled back");
        }
    }

    static void SetupData(string connectionString)
    {
        using (var connection = new MySqlConnection(connectionString))
        {
            connection.Open();
            using var command = connection.CreateCommand();
            command.CommandText = "create table if not exists tmp_mysql_connector_testing(id int not null primary key, val int)";
            command.ExecuteNonQuery();

            command.CommandText = "select count(*) from tmp_mysql_connector_testing";
            var rowCount = Convert.ToInt32(command.ExecuteScalar());
            if (rowCount == 0)
            {
                command.CommandText = "insert into tmp_mysql_connector_testing(id, val) values(1, 1)";
                command.ExecuteNonQuery();
            }
        }
    }
}