﻿using System.Text;
using MySql.Data.MySqlClient;

namespace Program2;

class Program
{
    static void Main(string[] args)
    {
        string connectionString = "server=127.0.0.1;User Id=scott;password=tiger;database=test_db;";

        for (;;)
        {
            Console.WriteLine("Program2: Press Enter to start transaction");
            Console.ReadLine();
            try
            {
                using (var connection = new MySqlConnection(connectionString))
                {
                    connection.Open();
                    using (var transaction = connection.BeginTransaction())
                    {
                        using var command = connection.CreateCommand();
                        command.CommandText = "update tmp_mysql_connector_testing set val = val + 1 where id = 1";
                        command.CommandTimeout = 5;
                        command.ExecuteNonQuery();
                        transaction.Commit();
                    }

                    Console.WriteLine("Program2: Transaction committed");
                }
            }
            catch (Exception ex)
            {
                var stringBuilder = new StringBuilder();
                stringBuilder.AppendLine("Program2: Exception:");
                while (ex != null)
                {
                    stringBuilder.AppendLine("    " + ex.Message);
                    ex = ex.InnerException;
                }

                Console.WriteLine(stringBuilder.ToString());
            }
        }
    }
}
